:: Batch-Datei fr eine automatisierte Sicherung von The Bat!
::
:: Erstellt von P. Jansen, 12.12.2003 
:: Modifiziert fr die alleinige Sicherung von TheBat!
:: am 20.12.2003 von C.Knobloch
::
:: Der Autor ist fr Schden/Verluste jeglicher Art nicht haftbar zu machen
:: Der Anwender trgt das Risiko der Nutzung 

@echo off
cls

echo Automatisierte Sicherung von The Bat!
echo --------------------------------------------
echo.

if not %OS%==Windows_NT goto nont

:: Heutige Sicherung bereits durchgefhrt?
FOR /F "TOKENS=*" %%I IN (backup.dat) DO SET LASTBACKUP=%%I
if "%LASTBACKUP%"=="%DATE%" goto end

:: Welche Dateien sollen gesichert werden?
:: The Bat! Installationsverzeichnis
set SOURCE_DIR="d:\thebat"

:: Wo sollen die gesicherten abgelegt werden?
set TARGET_DIR=H:\TheBat_Backup
 
set TARGET_DIR2=Backup#1
if exist "%TARGET_DIR%\%TARGET_DIR2%" set TARGET_DIR2=Backup#2
if exist "%TARGET_DIR%\%TARGET_DIR2%" set TARGET_DIR2=Backup#3
if exist "%TARGET_DIR%\%TARGET_DIR2%" set TARGET_DIR2=Backup#4
if exist "%TARGET_DIR%\%TARGET_DIR2%" set TARGET_DIR2=Backup#5
if exist "%TARGET_DIR%\%TARGET_DIR2%" set TARGET_DIR2=Backup#6
if exist "%TARGET_DIR%\%TARGET_DIR2%" set TARGET_DIR2=Backup#7
if exist "%TARGET_DIR%\%TARGET_DIR2%" set TARGET_DIR2=Backup#8
if exist "%TARGET_DIR%\%TARGET_DIR2%" set TARGET_DIR2=Backup#9
if exist "%TARGET_DIR%\%TARGET_DIR2%" set TARGET_DIR2=Backup#10
if not exist "%TARGET_DIR%\%TARGET_DIR2%"% goto jump1

rmdir "%TARGET_DIR%\Backup#1" /s /q
move "%TARGET_DIR%\Backup#2" "%TARGET_DIR%\Backup#1"
move "%TARGET_DIR%\Backup#3" "%TARGET_DIR%\Backup#2"
move "%TARGET_DIR%\Backup#4" "%TARGET_DIR%\Backup#3"
move "%TARGET_DIR%\Backup#5" "%TARGET_DIR%\Backup#4"
move "%TARGET_DIR%\Backup#6" "%TARGET_DIR%\Backup#5"
move "%TARGET_DIR%\Backup#7" "%TARGET_DIR%\Backup#6"
move "%TARGET_DIR%\Backup#8" "%TARGET_DIR%\Backup#7"
move "%TARGET_DIR%\Backup#9" "%TARGET_DIR%\Backup#8"
move "%TARGET_DIR%\Backup#10" "%TARGET_DIR%\Backup#9"

:jump1

:: Verzeichnis fr heutige Sicherung angelegen
set TARGET_DIR="%TARGET_DIR%\%TARGET_DIR2%"
md %TARGET_DIR%

:: Verzeichnis angelegt?
if not exist %TARGET_DIR% goto notargetdir

md %TARGET_DIR%\Data

:: Welches Programm wird fr die Sicherung benutzt?
set ARCHIVER=~RAR\rar.exe

:: Sicherungsprogramm im angegebenen Pfad vorhanden?
if not exist %ARCHIVER% goto noarchiver

:: Welche Einstellungen sollen fr die Sicherung benutzt werden?
set ARCHIVERCMD=%ARCHIVER% a -k -m3 -r -rr -dh -ep1

set XSOURCE_DIR=%SOURCE_DIR%\*.*

:: Welche Dateinamen sollen fr die Sicherung benutzt werden?
set RARFILE=TheBat!.rar
set REGFILE=TheBat!_reg.dat
set BATCHFILE=TheBat!_Backup.bat
set PROTFILE=Quelle.dat
set RESTOREFILE=TheBat!_Restore.bat

:: The Bat! Installationsverzeichnis korrekt?
if not exist %SOURCE_DIR%\thebat.exe goto nothebat

:: Sicherungsprogramm kopieren
copy ~RAR\unrar.exe %TARGET_DIR%\Data
if not exist %TARGET_DIR%\Data\unrar.exe goto nounrarfile

:: Sicherung durchfhren
%ARCHIVERCMD% %TARGET_DIR%\Data\%RARFILE% %XSOURCE_DIR%

:: The Bat! Einstellungen aus der Registry exportieren ...
regedit /e %REGFILE% HKEY_CURRENT_USER\Software\RIT

:: ... und in das Zielverzeichnis verschieben
move %REGFILE% %TARGET_DIR%\Data\%REGFILE%


:: Diese Batch-Datei ebenfalls sichern
copy %BATCHFILE% %TARGET_DIR%\Data\%BATCHFILE%.txt

:: Batch-Datei fr die Rcksicherung kopieren
copy %RESTOREFILE% %TARGET_DIR%\%RESTOREFILE%

:: Protokollieren, welches Verzeichnis fr die Sicherung benutzt wurde
echo %SOURCE_DIR%>%TARGET_DIR%\Data\%PROTFILE%

:: Prfen, ob alle Dateien vorhanden sind
if not exist %TARGET_DIR%\%RESTOREFILE% goto norestorefile
if not exist %TARGET_DIR%\Data\%RARFILE% goto norarfile
if not exist %TARGET_DIR%\Data\%REGFILE% goto noregfile
if not exist %TARGET_DIR%\Data\%BATCHFILE%.txt goto nobatchfile
if not exist %TARGET_DIR%\Data\%PROTFILE% goto noprotfile

:: Datum der letzten Sicherung speichern
:: echo %DATE%>backup.dat

goto end

:nont
echo.
echo FEHLER: Kein Windows NT System!
pause
goto end

:: Packprogramm nicht gefunden
:noarchiver
echo.
echo FEHLER: Packprogramm %ARCHIVER% nicht gefunden!
pause
goto end

:: Falsches The Bat! Installationsverzeichnis
:nothebat
echo.
echo FEHLER: Falsches The Bat! Installationsverzeichnis (SOURCE_DIR)!
pause
goto end

:: Sicherungsverzeichnis konnte nicht angelegt werden
:notargetdir
echo.
echo FEHLER: Sicherungsverzeichnis konnte nicht angelegt werden (TARGET_DIR)!
pause
goto end

:: Fehlende Dateien
:norarfile
echo.
echo FEHLER: Datei %TARGET_DIR%\Data\%RARFILE% nicht gefunden!
pause
goto end

:noregfile
echo.
echo FEHLER: Datei %TARGET_DIR%\Data\%REGFILE% nicht gefunden!
pause
goto end


:nobatchfile
echo.
echo FEHLER: Datei %TARGET_DIR%\Data\%BATCHFILE%.txt nicht gefunden!
pause
goto end

:norestorefile
echo.
echo FEHLER: Datei %TARGET_DIR%\%RESTOREFILE% nicht gefunden!
pause
goto end


:noprotfile
echo.
echo FEHLER: Datei %TARGET_DIR%\Data\%PROTFILE% nicht gefunden!
pause
goto end

:nounrarfile
echo.
echo FEHLER: Datei %TARGET_DIR%\Data\unrar.exe nicht gefunden!
pause
goto end

:: Sicherung beendet
:end
